/***************************************************************
 * Name:      idwMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    Wolfgang Gossel (wolfgang.gossel@geo.uni-halle.de)
 * Created:   2013-09-27
 * Copyright: Wolfgang Gossel (umweltgeologie.geologie.uni-halle.de)
 * License:   GPL
 **************************************************************/

#ifndef CALC_IDW_H
#define CALC_IDW_H
#include <vector>
#include <cmath>
#include <wx/wx.h>
#include <wx/log.h>
#include <algorithm>

using namespace std;

class calculate_IDW
{
    public:
        calculate_IDW();
        ~calculate_IDW();
        void setRaster(double xRasMin, double yRasMin, double xRasMax, double yRasMax, double rasWidth);
        void setPointData(vector<double> &xData, vector<double> &yData, vector<double> &zData);
        void calculateNumberMeasPoints(long powIDW, long numNeighbors, double searchRadius);
        void calculateRadiusMeasPoints(long powIDW, double searchRadius);
        void calculateAllMeasPoints(long powIDW);
        void getRasterData(vector<double> &xRasData, vector<double> &yRasData, vector<double> &zRasData);
        long getCols();
        long getRows();
    protected:
    private:
        long numberRasterCols, numberRasterRows, powerIDW, numberNeighborPoints;

        long *indexMeasureRas;
        double *distRasterPntMeasure;

        vector<double> xMeasure;
        vector<double> yMeasure;
        vector<double> zMeasure;
        //vector<double> distRasPointMeasure;

        vector<double> xRaster;
        vector<double> yRaster;
        vector<double> zRaster;

        vector<double> xSel;
        vector<double> ySel;
        vector<double> zSel;
        vector<double> distSel;
};

class sortForIDW
{
    public:
        sortForIDW(){};
        ~sortForIDW(){};
        static bool sortAscending(const sortForIDW &a, const sortForIDW &b);
        double getDist() {return distRM;}
        double getValue() {return valueM;}
//    private:
        double distRM;
        double valueM;
        long idM;
};

#endif // CALCULATE_IDW_H
