/***************************************************************
 * Name:      idwMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    Wolfgang Gossel (wolfgang.gossel@geo.uni-halle.de)
 * Created:   2013-09-27
 * Copyright: Wolfgang Gossel (umweltgeologie.geologie.uni-halle.de)
 * License:   GPL
 **************************************************************/
#include "export.h"

exportRaster::exportRaster()
{
    //ctor
}

exportRaster::~exportRaster()
{
    //dtor
}

void exportRaster::setRasterData(vector<double> &xRasData, vector<double> &yRasData, vector<double> &zRasData)
{
        xRaster=xRasData;
        yRaster=yRasData;
        zRaster=zRasData;
}

void exportRaster::writeGridFile(string strPathResFile, long nCols, long nRows, double xRasMin, double yRasMin, double rasWidth)
{

    long lngCounterCols, lngCounterRows;

    wxString tmpString;


    ofstream outFile(strPathResFile.c_str());

    outFile<<"ncols         "<<nCols<<"\n";
    outFile<<"nrows         "<<nRows<<"\n";
    outFile<<"xllcorner     "<<xRasMin<<"\n";
    outFile<<"yllcorner     "<<yRasMin<<"\n";
    outFile<<"cellsize      "<<rasWidth<<"\n";
    outFile<<"NODATA_value  -9999\n";

    for(lngCounterRows=nRows-1;lngCounterRows>0;lngCounterRows--)
    {
        for(lngCounterCols=0;lngCounterCols<nCols;lngCounterCols++)
        {
            outFile<<zRaster[lngCounterCols+lngCounterRows*nCols]<<" ";
        }
        outFile<<"\n";
    }


    outFile.close();

}
