/***************************************************************
 * Name:      getInput.h
 * Purpose:   Code for readaing and analyzing an ASCII-input file
 * Author:    Wolfgang Gossel (wolfgang.gossel@geo.uni-halle.de)
 * Created:   2013-11-09
 * Copyright: Wolfgang Gossel (umweltgeologie.geologie.uni-halle.de)
 * License:   GPL
 **************************************************************/
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <cmath>
//#include "getInput.cpp"
#include <wx/wx.h>

using namespace std;

class getPoints
{
    public:

        getPoints(){};
        ~getPoints(){};
        void setFile(string strInputFileName);
        void getPointsFromFile();
        void analyzeFileContentXYZ();
        void analyzeFileContentBNA();
        void analyzeFileContentGSLIB();
        //void set_short_Lines(long alti_num[], double altitude[], double longitude_s[], double latitude_s[], double longitude_e[], double latitude_e[]);
        long getNumberInputPoints();
        void findBoundaries();
        double getMaxX();
        double getMinX();
        double getMaxY();
        double getMinY();
        void getInputData(vector<double> &xData, vector<double> &yData, vector<double> &zData);

    private:
        wxString infile;
        const char *infile2;
        string file_content;
        long num_points;
        vector<double> xinput;
        vector<double> yinput;
        vector<double> zinput;
        double maxX;
        double maxY;
        double minX;
        double minY;
};
